﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using CLRCallbackWrapper;

namespace WpfApp
{
    /// <summary>
    /// MainWindow.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class MainWindow : Window
    {
        CallbackWrapper CLRWrapper = new CallbackWrapper();

        static MainWindow wnd;

        public MainWindow()
        {
            InitializeComponent();  
        }

        private void Button_RegisterFunc_Click(object sender, RoutedEventArgs e)
        {
            call.Background = Brushes.LightGray;
            CLRWrapper.registerCallbackFunc(MyCallback, 5, 6);
        }

        private void Button_CallFunc_Click(object sender, RoutedEventArgs e)
        {
            CLRWrapper.callFuncCB();
        }

        static void MyCallback(int pos)
        {
            wnd.call.Background = Brushes.Green;
            Console.WriteLine("This is user defined callback function.");

            wnd.CLRWrapper.deleteCallbackFunc();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            wnd = this;
        }
    }
}
